<template>
  <b-container fluid>
    <b-overlay :show="isBusy" rounded="sm">
      <b-row>
        <b-col cols="12" class="d-flex justify-content-between">
          <!-- filters here -->
        </b-col>
      </b-row>
      <b-row>
        <b-col cols="12">
          <b-table
            ref="table_automovements"
            :fields="fields"
            responsive
            striped
            :selectable="table_selectable"
            select-mode="single"
            selected-variant="primary"
            stacked="sm"
            :busy.sync="isBusy"
            :sort-by.sync="sortBy"
            :sort-desc.sync="sortDesc"
            :items="tableProvider"
            :current-page="currentPage"
            :per-page="perPage"
            @row-clicked="onRowClicked"
          >
            <template v-slot:cell(source_region)="data">
              {{ $_.get(data, 'item.source_region_object.name', '') }}
            </template>
            <template v-slot:cell(resource)="data">
              {{ $_.get(data, 'item.resource_object.name', '') }}
            </template>
            <template v-slot:cell(carrier)="data">
              {{ $_.get(data, 'item.carrier_object.name', '') }}
            </template>
            <template v-slot:cell(target_inventory)="data">
              {{ $_.get(data, 'item.target_inventory_object.owner_object.name', '') }}
            </template>
            <template v-slot:cell(actions)="data">
              <b-button
                variant="danger"
                @click="onDeleteButtonClick(data.item)"
              >
                Eliminar
              </b-button>
            </template>
          </b-table>
        </b-col>
      </b-row>
      <b-row>
        <b-col cols="12">
          <b-pagination
            align="center"
            :total-rows="totalRows"
            :per-page="perPage"
            v-model="currentPage"
          />
        </b-col>
      </b-row>
    </b-overlay>
    <b-modal
      ref="delete_item_modal"
      centered
      size="md"
      title="Eliminar"
      ok-variant="danger"
      ok-title="Eliminar"
      @ok="performDelete"
    >
      <b-alert
        variant="danger"
        v-model="autoMovementDeleteFailAlertShow"
      >
        Hubo un problema al eliminar el automatismo
      </b-alert>

      <div v-if="toDeleteItem">
        Desea elminar el automatismo?
        {{ toDeleteItem.pk }}
        <h4>Recurso</h4>
        {{ toDeleteItem.resource_object.name }}
        <h4>Destino</h4>
        {{ toDeleteItem.target_inventory_object.owner_object.name }}
        <h4>Transportista</h4>
        {{ toDeleteItem.carrier_object.name }}
      </div>


    </b-modal>
  </b-container>
</template>

<script>
import { mapActions } from "vuex";

export default {
  name: "auto-movements-list",
  props: {
    columns: {
      type: Array,
      default: function() {
        return [];
      }
    },
    table_selectable: {
      type: Boolean,
      default: false
    },
    lock_filters: {
      type: Object,
      default: function() {
        return {};
      }
    }
  },
  components: {},
  data() {
    return {
      filters: {},
      // table
      loading: true,
      isBusy: false,
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      sortBy: null,
      sortDesc: false,
      toDeleteItem: undefined,
      autoMovementDeleteFailAlertShow: false
    };
  },
  computed: {
    // ...mapState({
    //   availRoles: state => state.utils.availRoles,
    //   mappedAvailRoles: state => state.utils.mappedAvailRoles,
    //   availRequestStatuses: state => state.utils.availRequestStatuses,
    //   mappedAvailRequestStatuses: state =>
    //     state.utils.mappedAvailRequestStatuses
    // }),
    fields() {
      const avail_columns = {
        pk: {
          label: "ID",
          sortable: true
        },
        source_region: {
          label: "Region",
          sortable: true
        },
        resource: {
          label: "Producto",
          sortable: true
        },
        carrier: {
          label: "Transportista",
          sortable: true
        },
        target_inventory: {
          label: "Inventario destino",
          sortable: true
        },
        actions: {
          label: ""
        }
      };
      // return all columns or columns configured in props
      let columns = [];
      for (const key in avail_columns) {
        if (this.columns.length == 0 || this.columns.indexOf(key) >= 0) {
          columns.push(Object.assign({}, avail_columns[key], { key: key }));
        }
      }
      return columns;
    }
  },
  created() {},
  mounted() {
    // if (!this.availRequestStatuses) {
    //   this.LOAD_AVAIL_REQUEST_STATUSES();
    // }
    // if (!this.availRoles) {
    //   this.LOAD_AVAIL_ROLES();
    // }
  },
  methods: {
    ...mapActions({
      DELETE_AUTOMOVEMENT: "shipping/DELETE_AUTOMOVEMENT"
    }),
    tableProvider() {
      let offset = 0;
      var filters = {};
      if (this.perPage && this.currentPage) {
        offset = this.perPage * (this.currentPage - 1);
      }
      filters.offset = offset;
      filters.limit = this.perPage;
      if (this.sortBy) {
        filters["ordering"] = this.sortBy;
        if (this.sortDesc) {
          filters["ordering"] = "-" + filters["ordering"];
        }
      }
      filters = Object.assign(filters, this.filters);
      filters = Object.assign(filters, this.lock_filters);
      const uri = this.$parseurl(
        "/logistica/middle/person/{person_pk}/automovementconfig/",
        {
          person_pk: localStorage.getItem("pk_person")
        },
        filters
      );
      return new Promise((resolve, reject) => {
        this.$fetchget(uri).then(res => {
          res.json().then(data => {
            if (res.ok) {
              const items = data.results;
              this.loading = false;
              this.totalRows = data.count;
              this.$emit("loaded-rows", items);
              resolve(items);
              return items;
            } else {
              // TODO: LANZAR ERROR
              reject("error");
            }
          });
        });
      });
    },
    performDelete(evt) {
      evt.preventDefault();
      this.DELETE_AUTOMOVEMENT({
        person_pk: localStorage.getItem("pk_person"),
        automovementconfig_pk: this.toDeleteItem.pk
      }).then(
        () => {
          this.$refs.delete_item_modal.hide();
          this.$refs.table_automovements.refresh();
        },
        () => {
          this.autoMovementDeleteFailAlertShow = true;
          // TODO: show error
        }
      );
    },
    onDeleteButtonClick(item) {
      this.autoMovementDeleteFailAlertShow = false;
      this.toDeleteItem = Object.assign({}, item);
      this.$refs.delete_item_modal.show();
    },
    onRowClicked(data, index) {
      this.$emit(
        "automovement-click",
        Object.assign({}, data, { __row_index: index })
      );
    },
    onFilterChange() {
      this.$refs.table_automovements.refresh();
    },
    refresh() {
      this.$refs.table_automovements.refresh();
    },
    unselectRow(index) {
      this.$refs.table_automovements.unselectRow(index);
    },
    selectRow(index) {
      this.$refs.table_automovements.selectRow(index);
    }
  }
};
</script>
<style>
</style>
